CON
  _CLKMODE      = XTAL1 + PLL16X                        
  _XINFREQ      = 5_000_000

  ' Pin assignments
  RSpin =  1                   
  RWpin =  2                    
  Epin  =  3
  ' These must be four consecutive pins
  DB4pin = 4
  DB7pin = 7

  ' ASCII codes.
  CR  = 13
  LF  = 10
  PSTClearScreen = 16


OBJ
  DBG : "SimpleDebug"
  Delay : "delay"
  

VAR
  ' Variables for measuring delay.
  long Interval ' gets the number of clocks

  long gloops   ' for loops count

  ' Variables for measuring delay.
  long Overhead ' number of clocks consumed by measurement.


PUB main
  DBG.start(9600)
  Delay.sDelay( 5 ) ' time enough to switch to PST
  
  DBG.str(string(PSTClearScreen,"Starting delay testing program",CR))

  Init

  Measure

  repeat ' stall here


PRI Init
  ' Determine the overhead of measuring time
  Interval := -cnt    ' get the starting time
  Interval +=  cnt    ' ending time - starting time
  Overhead := Interval
  DBG.str( string("Measurement overhead: ") )
  DBG.dec( Overhead )
  DBG.str( string(" clock cycles",CR) )

  ' Now, verify that the overhead calculation was correct
  repeat while ( Interval <> 0 )
    ' Report the current overhead value
    DBG.str( string("Measurement overhead: ") )
    DBG.dec( Overhead )
    DBG.str( string(" clock cycles",CR) )

    ' Verify that it is correct
    Interval := -cnt
    Interval += cnt - Overhead
    if ( Interval <> 0 )
      DBG.str( string("Measurement overhead off by ",CR) )
      DBG.dec( Interval )
      DBG.str( string(" clock cycles",CR) )
      Overhead += Interval
    else ' Interval == 0  
      DBG.str( string("(Measurement overhead confirmed)",CR) )


PRI Measure
  ' measure the time of various delay techniques

  MeasureRepeats

  MeasureClocks

  MeasureUsDelay
  MeasureMsDelay
  MeasureSecDelay


PRI MeasureRepeats | lloops, repeatClocksl, repeatClocksg, repeatClocks2 
'' Measure the timing of the clocksDelay function(s)

  Interval := -cnt
  repeat 0
  Interval += cnt - Overhead
  repeatClocksl := Interval
  DBG.str( string(CR,"Clocks for 'repeat 0' ") )
  DBG.dec( repeatClocksl )
  DBG.str( string(CR) )
  
  Interval := -cnt
  repeat 1
  Interval += cnt - Overhead
  repeatClocksl := Interval
  DBG.str( string("Clocks for 'repeat 1' ") )
  DBG.dec( repeatClocksl )
  DBG.str( string(CR) )
  
  Interval := -cnt
  repeat 2
  Interval += cnt - Overhead
  repeatClocksl := Interval
  DBG.str( string("Clocks for 'repeat 2' ") )
  DBG.dec( repeatClocksl )
  DBG.str( string(CR) )
  
  Interval := -cnt
  repeat 3
  Interval += cnt - Overhead
  repeatClocksl := Interval
  DBG.str( string("Clocks for 'repeat 3' ") )
  DBG.dec( repeatClocksl )
  DBG.str( string(CR) )
  
  Interval := -cnt
  repeat 4
  Interval += cnt - Overhead
  repeatClocksl := Interval
  DBG.str( string("Clocks for 'repeat 4' ") )
  DBG.dec( repeatClocksl )
  DBG.str( string(CR) )
  
  Interval := -cnt
  repeat 5
  Interval += cnt - Overhead
  repeatClocksl := Interval
  DBG.str( string("Clocks for 'repeat 5' ") )
  DBG.dec( repeatClocksl )
  DBG.str( string(CR) )
  
  Interval := -cnt
  repeat 6
  Interval += cnt - Overhead
  repeatClocksl := Interval
  DBG.str( string("Clocks for 'repeat 6' ") )
  DBG.dec( repeatClocksl )
  DBG.str( string(CR) )
  
  Interval := -cnt
  repeat 7
  Interval += cnt - Overhead
  repeatClocksl := Interval
  DBG.str( string("Clocks for 'repeat 7' ") )
  DBG.dec( repeatClocksl )
  DBG.str( string(CR) )
  
  Interval := -cnt
  repeat 8
  Interval += cnt - Overhead
  repeatClocksl := Interval
  DBG.str( string("Clocks for 'repeat 8' ") )
  DBG.dec( repeatClocksl )
  DBG.str( string(CR) )
  
  Interval := -cnt
  repeat 9
  Interval += cnt - Overhead
  repeatClocksl := Interval
  DBG.str( string("Clocks for 'repeat 9' ") )
  DBG.dec( repeatClocksl )
  DBG.str( string(CR) )

  Interval := -cnt
  repeat 10
  Interval += cnt - Overhead
  repeatClocksl := Interval
  DBG.str( string("Clocks for 'repeat 10' ") )
  DBG.dec( repeatClocksl )
  DBG.str( string(CR) )
  
  Interval := -cnt
  repeat 11
  Interval += cnt - Overhead
  repeatClocksl := Interval
  DBG.str( string("Clocks for 'repeat 11' ") )
  DBG.dec( repeatClocksl )
  DBG.str( string(CR) )
  
  Interval := -cnt
  repeat 12
  Interval += cnt - Overhead
  repeatClocksl := Interval
  DBG.str( string("Clocks for 'repeat 12' ") )
  DBG.dec( repeatClocksl )
  DBG.str( string(CR) )
  
  Interval := -cnt
  repeat 13
  Interval += cnt - Overhead
  repeatClocksl := Interval
  DBG.str( string("Clocks for 'repeat 13' ") )
  DBG.dec( repeatClocksl )
  DBG.str( string(CR) )
  
  Interval := -cnt
  repeat 14
  Interval += cnt - Overhead
  repeatClocksl := Interval
  DBG.str( string("Clocks for 'repeat 14' ") )
  DBG.dec( repeatClocksl )
  DBG.str( string(CR) )
  
  Interval := -cnt
  repeat 15
  Interval += cnt - Overhead
  repeatClocksl := Interval
  DBG.str( string("Clocks for 'repeat 15' ") )
  DBG.dec( repeatClocksl )
  DBG.str( string(CR) )
  
  Interval := -cnt
  repeat 16
  Interval += cnt - Overhead
  repeatClocksl := Interval
  DBG.str( string("Clocks for 'repeat 16' ") )
  DBG.dec( repeatClocksl )
  DBG.str( string(CR) )
  
  Interval := -cnt
  repeat 17
  Interval += cnt - Overhead
  repeatClocksl := Interval
  DBG.str( string("Clocks for 'repeat 17' ") )
  DBG.dec( repeatClocksl )
  DBG.str( string(CR) )
  
  Interval := -cnt
  repeat 18
  Interval += cnt - Overhead
  repeatClocksl := Interval
  DBG.str( string("Clocks for 'repeat 18' ") )
  DBG.dec( repeatClocksl )
  DBG.str( string(CR) )
  
  Interval := -cnt
  repeat 19
  Interval += cnt - Overhead
  repeatClocksl := Interval
  DBG.str( string("Clocks for 'repeat 19' ") )
  DBG.dec( repeatClocksl )
  DBG.str( string(CR) )

  
PRI MeasureUsDelay | usClocks
'' Measure the timing of the usDelay function(s)

  Interval := -cnt
  Delay.usDelayShort( 0 )
  Interval += cnt - Overhead
  usClocks := Interval
  DBG.str( string(CR,"Minimum clocks for usDelayShort function: ") )
  DBG.dec( usClocks )
  DBG.str( string(CR) )
  ' min clocks: 4304, or 53.8 us at 80 MHz, 43.04 us at 100 MHz
  ' so we want 80*54 clocks -- 4320 for 54 us
  '            80*55 clocks -- 4400 for 55 us.

  Interval := -cnt
  Delay.usDelayShort( 54 )
  Interval += cnt - Overhead
  usClocks := Interval
  DBG.str( string(CR,"For 54 us, expected 4320 clocks, got: ") )
  DBG.dec( usClocks )
  DBG.str( string(CR) )

  Interval := -cnt
  Delay.usDelayShort( 55 )
  Interval += cnt - Overhead
  usClocks := Interval
  DBG.str( string(CR,"For 55 us, expected 4400 clocks, got: ") )
  DBG.dec( usClocks )
  DBG.str( string(CR) )

  Interval := -cnt
  Delay.usDelayShort( 56 )
  Interval += cnt - Overhead
  usClocks := Interval
  DBG.str( string(CR,"For 56 us, expected 4480 clocks, got: ") )
  DBG.dec( usClocks )
  DBG.str( string(CR) )

  ' Start the usDelay tests, with a "short" one, to see the minimum
  ' time it can take.
  
  Interval := -cnt
  Delay.usDelay( 50 )
  Interval += cnt - Overhead
  usClocks := Interval
  DBG.str( string(CR,"Minimum clock count for usDelay: ") )
  DBG.dec( usClocks )
  DBG.str( string(CR) )

  ' try a big number, to check the (small) overhead value  
  Interval := -cnt
  Delay.usDelay( 5_000 )
  Interval += cnt - Overhead
  usClocks := Interval
  DBG.str( string(CR,"Tested usDelay(5_000): expected 400000 clocks, got ") )
  DBG.dec( usClocks )
  DBG.str( string(CR) )

  Interval := -cnt
  Delay.usDelay( 1_000_000 )
  Interval += cnt - Overhead
  usClocks := Interval
  DBG.str( string(CR,"Tested usDelay(1_000_000): expected 80000000 clocks, got ") )
  DBG.dec( usClocks )
  DBG.str( string(CR) )

  Interval := -cnt
  Delay.usDelay( 3_000_000 )
  Interval += cnt - Overhead
  usClocks := Interval
  DBG.str( string(CR,"Tested usDelay(3_000_000): expected 240000000 clocks, got ") )
  DBG.dec( usClocks )
  DBG.str( string(CR) )

  Interval := -cnt
  Delay.usDelay( 6_000_000 )
  Interval += cnt - Overhead
  usClocks := Interval
  DBG.str( string(CR,"Tested usDelay(6_000_000): expected 480000000 clocks, got ") )
  DBG.dec( usClocks )
  DBG.str( string(CR) )


PRI MeasureMsDelay | msClocks
'' Measure the timing of the msDelay function

  Interval := -cnt
  Delay.msDelay( 10 )
  Interval += cnt - Overhead
  msClocks := Interval
  DBG.str( string(CR,"Tested msDelay(10): expected 800000 clocks, got ") )
  DBG.dec( msClocks )
  DBG.str( string(CR) )

  Interval := -cnt
  Delay.msDelay( 200 )
  Interval += cnt - Overhead
  msClocks := Interval
  DBG.str( string(CR,"Tested msDelay(200): expected 16000000 clocks, got ") )
  DBG.dec( msClocks )
  DBG.str( string(CR) )

  Interval := -cnt
  Delay.msDelay( 3_000 )
  Interval += cnt - Overhead
  msClocks := Interval
  DBG.str( string(CR,"Tested msDelay(3_000): expected 240000000 clocks, got ") )
  DBG.dec( msClocks )
  DBG.str( string(CR) )

  Interval := -cnt
  Delay.msDelay( 5_000 )
  Interval += cnt - Overhead
  msClocks := Interval
  DBG.str( string(CR,"Tested msDelay(5_000): expected 400000000 clocks, got ") )
  DBG.dec( msClocks )
  DBG.str( string(CR) )


PRI MeasureSecDelay | secClocks
'' Measure the timing of the msDelay function

  Interval := -cnt
  Delay.sDelay( 1 )
  Interval += cnt - Overhead
  secClocks := Interval
  DBG.str( string(CR,"Tested sDelay(1): expected 80000000 clocks, got ") )
  DBG.dec( secClocks )
  DBG.str( string(CR) )

  Interval := -cnt
  Delay.sDelay( 2 )
  Interval += cnt - Overhead
  secClocks := Interval
  DBG.str( string(CR,"Tested sDelay(2): expected 160000000 clocks, got ") )
  DBG.dec( secClocks )
  DBG.str( string(CR) )

  Interval := -cnt
  Delay.sDelay( 5 )
  Interval += cnt - Overhead
  secClocks := Interval
  DBG.str( string(CR,"Tested sDelay(5): expected 400000000 clocks, got ") )
  DBG.dec( secClocks )
  DBG.str( string(CR) )

  Interval := -cnt
  Delay.sDelay( 10 )
  Interval += cnt - Overhead
  secClocks := Interval
  DBG.str( string(CR,"Tested sDelay(10): expected 800000000 clocks, got ") )
  DBG.dec( secClocks )
  DBG.str( string(CR) )



PRI MeasureClocks | emptyClocks, clocksDelayClocks
'' Measure the timing of the clocksDelay function(s)
{
  Interval := -cnt
  Delay.emptyDelay
  Interval += cnt - Overhead
  emptyClocks := Interval
  DBG.str( string(CR,"Clocks for call to empty function: ") )
  DBG.dec( emptyClocks )
  DBG.str( string(CR) )

  ' Measure the minimum overhead for a very short variable clock count delay
  Interval := -cnt
  Delay.clocksDelay( 1 )
  Interval += cnt - Overhead
  clocksDelayClocks := Interval
  DBG.str( string(CR,"Minimum clocks for call to very short delay function: ") )
  DBG.dec( clocksDelayClocks )
  DBG.str( string(CR) )
  ' This takes 1520 clocks

  ' Measure the minimum time if we actually use a waitcnt
  Interval := -cnt
  Delay.clocksDelay( 2000 )
  Interval += cnt - Overhead
  clocksDelayClocks := Interval
  DBG.str( string(CR,"Minimum clocks for call to waitcnt delay function: ") )
  DBG.dec( clocksDelayClocks )
  DBG.str( string(CR) )
  ' This takes 3024 or 3056 clocks

  Interval := -cnt
  Delay.clocksDelay2( 3024 )
  Interval += cnt - Overhead
  clocksDelayClocks := Interval
  DBG.str( string(CR,"Fixed clock: expected 3024, got: ") )
  DBG.dec( clocksDelayClocks )
  DBG.str( string(CR) )
  
  Interval := -cnt
  Delay.clocksDelay2( 3025 )
  Interval += cnt - Overhead
  clocksDelayClocks := Interval
  DBG.str( string(CR,"Fixed clock: expected 3025, got: ") )
  DBG.dec( clocksDelayClocks )
  DBG.str( string(CR) )
  
  Interval := -cnt
  Delay.clocksDelay2( 3039 )
  Interval += cnt - Overhead
  clocksDelayClocks := Interval
  DBG.str( string(CR,"Fixed clock: expected 3039, got: ") )
  DBG.dec( clocksDelayClocks )
  DBG.str( string(CR) )
  
  Interval := -cnt
  Delay.clocksDelay2( 3040 )
  Interval += cnt - Overhead
  clocksDelayClocks := Interval
  DBG.str( string(CR,"Fixed clock: expected 3040, got: ") )
  DBG.dec( clocksDelayClocks )
  DBG.str( string(CR) )
  
  Interval := -cnt
  Delay.clocksDelay2( 3041 )
  Interval += cnt - Overhead
  clocksDelayClocks := Interval
  DBG.str( string(CR,"Fixed clock: expected 3041, got: ") )
  DBG.dec( clocksDelayClocks )
  DBG.str( string(CR) )

  

  ' Measure the minimum time if we actually use a waitcnt
  Interval := -cnt
  Delay.clocksDelay2( 2300 )
  Interval += cnt - Overhead
  clocksDelayClocks := Interval
  DBG.str( string(CR,"Minimum clocks for call to waitcnt delay function 2: ") )
  DBG.dec( clocksDelayClocks )
  DBG.str( string(CR) )
  ' This takes 2336 clocks
  
  Interval := -cnt
  Delay.clocksDelay2( 2352 )
  Interval += cnt - Overhead
  clocksDelayClocks := Interval
  DBG.str( string(CR,"Fixed clock: expected 2352, got: ") )
  DBG.dec( clocksDelayClocks )
  DBG.str( string(CR) )
  
  Interval := -cnt
  Delay.clocksDelay2( 2353 )
  Interval += cnt - Overhead
  clocksDelayClocks := Interval
  DBG.str( string(CR,"Fixed clock: expected 2353, got: ") )
  DBG.dec( clocksDelayClocks )
  DBG.str( string(CR) )
}


{
PRI MeasureBitSet | tildeClocks, assignClocks
  ' Comare the number of clock cycles it takes to set a bit
  ' in the OUTA register.
  ' - OUTA[RW]~
  ' - OUTA[RW] := 1

  Interval := -cnt
  OUTA[RW]~~
  Interval += cnt - Overhead
  tildeClocks := Interval

  Interval := -cnt
  OUTA[RW] := 1
  Interval += cnt - Overhead
  assignClocks := Interval

  DBG.str( string(CR,"Clocks to set one bit:") )
  DBG.str( string(CR,"tildes: ") )
  DBG.dec( tildeClocks )
  DBG.str( string(CR,"assign: ") )
  DBG.dec( assignClocks )
  DBG.str( string(CR) )

PRI MeasureBitClear | tildeClocks, assignClocks
  ' Comare the number of clock cycles it takes to clear a bit
  ' in the OUTA register.
  ' - OUTA[RW]~~
  ' - OUTA[RW] := 0

  Interval := -cnt
  OUTA[RW]~
  Interval += cnt - Overhead
  tildeClocks := Interval

  Interval := -cnt
  OUTA[RW] := 0
  Interval += cnt - Overhead
  assignClocks := Interval

  DBG.str( string(CR,"Clocks to clear one bit:") )
  DBG.str( string(CR,"tildes: ") )
  DBG.dec( tildeClocks )
  DBG.str( string(CR,"assign: ") )
  DBG.dec( assignClocks )
  DBG.str( string(CR) )
}
  